%bcond_without qt

%define major		0
%define libname		%mklibname v4l %{major}
%define develname	%mklibname v4l -d
%define wrappersname	%mklibname v4l-wrappers

Name:		v4l-utils
Version:	1.30.1
Release:	%mkrel 1
Summary:	Linux V4L2 and DVB API utilities
License:	LGPLv2+
Group:		System/Libraries
URL:		https://git.linuxtv.org/v4l-utils.git
Source0:	https://linuxtv.org/downloads/%{name}/%{name}-%{version}.tar.xz

BuildRequires:	meson
BuildRequires:	clang
BuildRequires:	doxygen
BuildRequires:	libsysfs-devel
BuildRequires:	pkgconfig(alsa)
BuildRequires:	pkgconfig(gl)
BuildRequires:	pkgconfig(glu)
BuildRequires:	pkgconfig(json-c)
BuildRequires:	pkgconfig(libbpf)
BuildRequires:	pkgconfig(libelf)
BuildRequires:	pkgconfig(libjpeg)
%if %{with qt}
BuildRequires:	cmake(Qt6Core5Compat)
BuildRequires:	cmake(Qt6Core)
BuildRequires:	cmake(Qt6Gui)
BuildRequires:	cmake(Qt6Help)
BuildRequires:	cmake(Qt6OpenGL)
BuildRequires:	cmake(Qt6OpenGLWidgets)
BuildRequires:	cmake(Qt6Widgets)
%endif
BuildRequires:	pkgconfig(sdl2)
BuildRequires:	pkgconfig(SDL2_image)
BuildRequires:	pkgconfig(udev)
BuildRequires:	pkgconfig(xmlrpc)
BuildRequires:	pkgconfig(x11)

Requires:	%{wrappersname} >= %{version}-%{release}
Provides:	edid-decode = %{version}-%{release}
Obsoletes:	edid-decode < 1

%description
v4l-utils is the combination of various v4l and dvb utilities which
used to be part of the v4l-dvb mercurial kernel tree.

%package -n	v4l-utils-qt
Summary:	Qt6 tools for v4l applications
Group:		System/Libraries
Provides:	v4l-utils-qt5 = %{version}-%{release}
Obsoletes:	v4l-utils-qt5 < 1.26.1-2

%description -n	v4l-utils-qt
v4l-utils-qt is a Qt6 gui for the v4l-utils tools.

%package -n	%{wrappersname}
Summary:	Wrappers for v4l applications
Group:		System/Libraries

%description -n %{wrappersname}
This package contains wrapper libraries that adds v4l2 device
compatibility for v4l1 applications and support for various
pixelformats to v4l2 applications.

%package -n	%{libname}
Summary:	Thin abstraction layer for video4linux2 devices
Group:		System/Libraries
Requires:	%{name} >= %{version}

%description -n %{libname}
libv4l is a collection of libraries which adds a thin abstraction
layer on top of video4linux2 devices. The purpose of this (thin)
layer is to make it easy for application writers to support a wide
variety of devices without having to write separate code for
different devices in the same class.

%package -n	%{develname}
Summary:	Development files from libv4l
Group:		Development/C
Requires:	%{libname} = %{version}-%{release}
Provides:	%{name}-devel = %{version}-%{release}
Provides:	libv4l-devel = %{version}-%{release}

%description -n %{develname}
This package contains the development files needed to build
programs that use libv4l.

%prep
%autosetup -p1

%build
%meson -Ddoxygen-man=true -Dgconv=disabled
%meson_build

%install
%meson_install

%find_lang %{name}
%find_lang libdvbv5

# already provided by ivtv-utils package, more uptodate/complete there
rm -f %{buildroot}%{_bindir}/ivtv-ctl

%files -f %{name}.lang -f libdvbv5.lang
%{_bindir}/cec-compliance
%{_bindir}/cec-ctl
%{_bindir}/cec-follower
%{_bindir}/cx18-ctl
%{_bindir}/decode_tm6000
%{_bindir}/dvb-fe-tool
%{_bindir}/dvb-format-convert
%{_bindir}/dvbv5-daemon
%{_bindir}/dvbv5-scan
%{_bindir}/dvbv5-zap
%{_bindir}/edid-decode
%{_bindir}/ir-ctl
%{_bindir}/ir-keytable
%{_bindir}/media-ctl
%{_bindir}/rds-ctl
%{_bindir}/v4l2-compliance
%{_bindir}/v4l2-ctl
%{_bindir}/v4l2-sysfs-path
%{_bindir}/v4l2-tracer
%{_sbindir}/v4l2-dbg
# In a wrong directory??
%exclude %{_unitdir}/systemd-udevd.service.d/50-rc_keymap.conf
%{_prefix}/lib/udev/rc_keymaps
%dir %{_sysconfdir}/rc_keymaps
%{_sysconfdir}/rc_maps.cfg
%{_udevrulesdir}/70-infrared.rules
%{_mandir}/man*/*

%if %{with qt}
%files -n	v4l-utils-qt
%{_bindir}/qv4l2
%{_bindir}/qvidcap
%{_datadir}/applications/qv4l2.desktop
%{_datadir}/applications/qvidcap.desktop
%{_iconsdir}/hicolor/*/apps/qv4l2.*
%{_iconsdir}/hicolor/*/apps/qvidcap.*
%endif

%files -n	%{wrappersname}
%dir %{_libdir}/libv4l
%dir %{_libdir}/libv4l/plugins
%{_libdir}/libv4l/v4l1compat.so
%{_libdir}/libv4l/v4l2convert.so
%{_libdir}/libv4l/*-decomp
%{_libdir}/libv4l/plugins/libv4l-mplane.so

%files -n	%{libname}
%{_libdir}/libdvbv5.so.%{major}{,.*}
%{_libdir}/libv4l1.so.%{major}{,.*}
%{_libdir}/libv4l2.so.%{major}{,.*}
%{_libdir}/libv4l2rds.so.%{major}{,.*}
%{_libdir}/libv4lconvert.so.%{major}{,.*}

%files -n	%{develname}
%dir %{_docdir}/%{name}
%{_docdir}/%{name}/html/
%{_includedir}/libdvbv5/
%{_includedir}/libv4l-plugin.h
%{_includedir}/libv4l1.h
%{_includedir}/libv4l1-videodev.h
%{_includedir}/libv4l2.h
%{_includedir}/libv4l2rds.h
%{_includedir}/libv4lconvert.h
%{_libdir}/libdvbv5.so
%{_libdir}/libv4l1.so
%{_libdir}/libv4l2.so
%{_libdir}/libv4l2rds.so
%{_libdir}/libv4lconvert.so
%{_libdir}/libv4l2tracer.so
%{_libdir}/pkgconfig/libdvbv5.pc
%{_libdir}/pkgconfig/libv4l1.pc
%{_libdir}/pkgconfig/libv4l2.pc
%{_libdir}/pkgconfig/libv4l2rds.pc
%{_libdir}/pkgconfig/libv4lconvert.pc


%changelog
* Sat May 24 2025 daviddavid <daviddavid> 1.30.1-1.mga10
+ Revision: 2186227
- new version: 1.30.1
- provides and obsoletes edid-decode which has moved to v4l-utils upstream

* Thu Aug 08 2024 daviddavid <daviddavid> 1.28.1-1.mga10
+ Revision: 2084186
- new version: 1.28.1
- switch to Qt6

* Mon Jan 22 2024 daviddavid <daviddavid> 1.26.1-1.mga10
+ Revision: 2033485
- new version: 1.26.1
- switch to meson build system

* Tue Oct 31 2023 daviddavid <daviddavid> 1.24.1-1.mga10
+ Revision: 2002988
- new version: 1.24.1

* Thu May 04 2023 daviddavid <daviddavid> 1.22.1-3.mga9
+ Revision: 1955802
- fix owner of include dir

* Sun Apr 03 2022 umeabot <umeabot> 1.22.1-2.mga9
+ Revision: 1842833
- Mageia 9 Mass Rebuild

* Mon Jan 03 2022 luigiwalser <luigiwalser> 1.22.1-1.mga9
+ Revision: 1766671
- 1.22.1
- add patch from fedora to fix build with newer gcc

* Thu Dec 17 2020 umeabot <umeabot> 1.20.0-3.mga8
+ Revision: 1660126
- Rebuild for new Qt5

* Mon Nov 30 2020 akien <akien> 1.20.0-2.mga8
+ Revision: 1650773
- Rebuild for llvm 11

* Tue Nov 03 2020 akien <akien> 1.20.0-1.mga8
+ Revision: 1642280
- Version 1.20.0

* Mon Jul 06 2020 joequant <joequant> 1.18.0-3.mga8
+ Revision: 1602545
- fix gcc10 patch

* Tue Feb 18 2020 umeabot <umeabot> 1.18.0-2.mga8
+ Revision: 1541794
- Mageia 8 Mass Rebuild
+ wally <wally>
- replace deprecated %%configure2_5x

* Thu Jan 02 2020 luigiwalser <luigiwalser> 1.18.0-1.mga8
+ Revision: 1475427
- 1.18.0

* Mon May 06 2019 akien <akien> 1.16.6-1.mga7
+ Revision: 1396571
- Version 1.16.6

* Wed May 01 2019 daviddavid <daviddavid> 1.16.5-4.mga7
+ Revision: 1396019
- actually uses upstream fixes for libdvbv5 (mga#24711)

* Fri Apr 26 2019 daviddavid <daviddavid> 1.16.5-3.mga7
+ Revision: 1395396
- add patch to revert libdvbv5 leaks and double free in dvb_fe_open thus
  fixing kaffeine issue (mga#24711#c7)

* Thu Apr 25 2019 daviddavid <daviddavid> 1.16.5-2.mga7
+ Revision: 1395270
- backport upstream fixes for for libdvbv5 (mga#24711)

* Sat Apr 13 2019 daviddavid <daviddavid> 1.16.5-1.mga7
+ Revision: 1389593
- new version: 1.16.5

* Tue Apr 02 2019 umeabot <umeabot> 1.16.3-2.mga7
+ Revision: 1385217
- Qt5 Rebuild

* Fri Dec 28 2018 luigiwalser <luigiwalser> 1.16.3-1.mga7
+ Revision: 1345651
- 1.16.3

* Sun Nov 11 2018 daviddavid <daviddavid> 1.16.2-1.mga7
+ Revision: 1329554
- new version: 1.16.2

* Sun Nov 04 2018 daviddavid <daviddavid> 1.16.1-1.mga7
+ Revision: 1328065
- new version: 1.16.1
- remove merged upstream patch

* Tue Oct 02 2018 daviddavid <daviddavid> 1.14.2-2.mga7
+ Revision: 1315668
- add patch to fix build with new glibc
+ umeabot <umeabot>
- Mageia 7 Mass Rebuild

* Mon May 14 2018 akien <akien> 1.14.2-1.mga7
+ Revision: 1229528
- Version 1.14.2

* Tue May 16 2017 luigiwalser <luigiwalser> 1.12.5-1.mga6
+ Revision: 1102063
- 1.12.5

* Mon May 08 2017 akien <akien> 1.12.4-1.mga6
+ Revision: 1099707
- Version 1.12.4

* Fri Mar 10 2017 akien <akien> 1.12.3-2.mga6
+ Revision: 1091584
- Enable ALSA support
- Rename -qt4 package to -qt5
+ ghibo <ghibo>
- Update to release 1.12.3.
- Added Patch1 because of missed symbols during linking.

* Tue Jul 05 2016 akien <akien> 1.10.1-1.mga6
+ Revision: 1039045
- Version 1.10.1

* Mon Jan 25 2016 luigiwalser <luigiwalser> 1.10.0-1.mga6
+ Revision: 927489
- 1.10.0

* Tue Oct 27 2015 ycantin <ycantin> 1.8.1-1.mga6
+ Revision: 895792
- new version 1.8.1
- add lang files

* Sun Jun 21 2015 luigiwalser <luigiwalser> 1.6.2-1.mga6
+ Revision: 837339
- remove upstreamed patches
- 1.6.2

* Tue Feb 03 2015 lmenut <lmenut> 1.4.0-4.mga5
+ Revision: 813237
- add upstream patches from stable-1.4 branch to fix buffer pool activation
  (mga#14499)

* Wed Oct 15 2014 umeabot <umeabot> 1.4.0-3.mga5
+ Revision: 742392
- Second Mageia 5 Mass Rebuild

* Tue Sep 16 2014 umeabot <umeabot> 1.4.0-2.mga5
+ Revision: 690115
- Mageia 5 Mass Rebuild

* Mon Sep 08 2014 akien <akien> 1.4.0-1.mga5
+ Revision: 673755
- Version 1.4.0

* Wed Jul 02 2014 luigiwalser <luigiwalser> 1.2.1-1.mga5
+ Revision: 642388
- 1.2.1

* Fri Feb 14 2014 luigiwalser <luigiwalser> 1.0.1-1.mga5
+ Revision: 591404
- 1.0.1

* Sat Oct 19 2013 umeabot <umeabot> 1.0.0-2.mga4
+ Revision: 532167
- Mageia 4 Mass Rebuild

* Sat Aug 17 2013 fwang <fwang> 1.0.0-1.mga4
+ Revision: 467221
- update file list
- update file list
- new version 1.0.0

* Sat Jun 15 2013 luigiwalser <luigiwalser> 0.9.5-2.mga4
+ Revision: 443532
- BR udev-devel

* Sat Jun 15 2013 luigiwalser <luigiwalser> 0.9.5-1.mga4
+ Revision: 443526
- 0.9.5
- BR libglu-devel
- use configure script
- update files list

* Mon Jan 14 2013 umeabot <umeabot> 0.8.9-2.mga3
+ Revision: 385213
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Tue Oct 30 2012 luigiwalser <luigiwalser> 0.8.9-1.mga3
+ Revision: 311670
- 0.8.9

* Mon Aug 13 2012 luigiwalser <luigiwalser> 0.8.8-1.mga3
+ Revision: 281023
- spec fixes from mdv
+ tv <tv>
- new release

* Fri Mar 02 2012 fwang <fwang> 0.8.6-1.mga2
+ Revision: 216631
- new version 0.8.6
+ tv <tv>
- further fix file list
- fix file list
- new release

* Tue Jun 14 2011 tv <tv> 0.8.4-1.mga2
+ Revision: 106077
- adjust file list
- fix udev rules path
- new release

* Wed Apr 13 2011 tv <tv> 0.8.3-1.mga1
+ Revision: 84184
- adjust file list
- new release

* Sat Jan 15 2011 mikala <mikala> 0.8.1-1.mga1
+ Revision: 18523
- imported package v4l-utils


* Sun Sep 05 2010 Götz Waschk <waschk@mandriva.org> 0.8.1-1mdv2011.0
+ Revision: 576131
- new version
- new source URL

* Thu Jul 15 2010 Tomasz Pawel Gajc <tpg@mandriva.org> 0.8.0-1mdv2011.0
+ Revision: 553711
- update to new version 0.8.0
- drop patch 0

* Wed Jun 16 2010 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 0.7.91-6mdv2010.1
+ Revision: 548175
- Add patch with updated upside-down device table entries, from upstream
  git (contains new device entry for reported laptop at MDV #58061).

* Thu Apr 08 2010 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 0.7.91-5mdv2010.1
+ Revision: 533193
- Added provides for libv4l-devel after package naming change (#58660).

* Sat Mar 27 2010 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 0.7.91-4mdv2010.1
+ Revision: 527886
- Do not provide ivtv-ctl, ivtv-utils already provides a more uptodate
  copy (#58419).

* Thu Mar 25 2010 Christophe Fergeau <cfergeau@mandriva.com> 0.7.91-3mdv2010.1
+ Revision: 527530
- forgot to set a non-empty description for new subpackage
- split qt4 util in its own subpackage

* Fri Mar 19 2010 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 0.7.91-1mdv2010.1
+ Revision: 525356
- Add BuildRequires for libsysfs-devel (to provide v4l2-sysfs-path).
- Remove uneeded BuildRequires.
- Update to v4l-utils 0.7.91, finish renaming in spec.
- Rename spec file.
- Rename libv4l to v4l-utils (#58203).

* Mon Jan 18 2010 Götz Waschk <waschk@mandriva.org> 0.6.4-1mdv2010.1
+ Revision: 492998
- update to new version 0.6.4

* Thu Nov 12 2009 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 0.6.3-1mdv2010.1
+ Revision: 465441
- Updated to version 0.6.3

* Tue Sep 01 2009 Götz Waschk <waschk@mandriva.org> 0.6.1-1mdv2010.0
+ Revision: 423820
- update to new version 0.6.1

* Wed Aug 19 2009 Emmanuel Andry <eandry@mandriva.org> 0.6.0-1mdv2010.0
+ Revision: 418064
- New version 0.6.0
- update files list

* Sun Jul 05 2009 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 0.5.9-2mdv2010.0
+ Revision: 392560
- Create subpackage for libv4l wrappers using mklibname, to allow
  installation of i586 and x86_64 wrapper versions on x86_64 (#45316).

* Sun Jun 07 2009 Funda Wang <fwang@mandriva.org> 0.5.9-1mdv2010.0
+ Revision: 383472
- New version 0.5.9

* Mon Jan 12 2009 Götz Waschk <waschk@mandriva.org> 0.5.8-1mdv2009.1
+ Revision: 328576
- update to new version 0.5.8

* Wed Dec 03 2008 Götz Waschk <waschk@mandriva.org> 0.5.7-1mdv2009.1
+ Revision: 309698
- update to new version 0.5.7

* Tue Nov 25 2008 Götz Waschk <waschk@mandriva.org> 0.5.6-1mdv2009.1
+ Revision: 306596
- update to new version 0.5.6

  + Pascal Terjan <pterjan@mandriva.org>
    - Update to 0.5.4

* Mon Oct 27 2008 Götz Waschk <waschk@mandriva.org> 0.5.3-1mdv2009.1
+ Revision: 297759
- update to new version 0.5.3

* Mon Oct 27 2008 Funda Wang <fwang@mandriva.org> 0.5.2-1mdv2009.1
+ Revision: 297522
- New version 0.5.2

* Tue Oct 21 2008 Götz Waschk <waschk@mandriva.org> 0.5.1-1mdv2009.1
+ Revision: 295932
- update to new version 0.5.1

* Fri Sep 05 2008 Frederic Crozat <fcrozat@mandriva.com> 0.4.3-1mdv2009.0
+ Revision: 281080
- Release 0.4.3

* Mon Sep 01 2008 Götz Waschk <waschk@mandriva.org> 0.4.1-2mdv2009.0
+ Revision: 278499
- depend on the main package

* Thu Aug 28 2008 Thierry Vignaud <tv@mandriva.org> 0.4.1-1mdv2009.0
+ Revision: 276810
- new release

* Thu Aug 07 2008 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 0.4.0-2mdv2009.0
+ Revision: 265667
- Bump release because of previous submit stuck in bs upload queue.
- Updated to version 0.4.0

* Thu Jul 31 2008 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 0.3.8-1mdv2009.0
+ Revision: 258489
- import libv4l

